<?php

namespace backend\modules\card\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\card\models\ResumeTemplate;

/**
 * ResumeTemplateSearch represents the model behind the search form of `backend\modules\card\models\ResumeTemplate`.
 */
class ResumeTemplateSearch extends ResumeTemplate
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'status'], 'integer'],
            [['title', 'created_at', 'updated_at', 'template_body', 'header_text', 'header_image', 'footer_text', 'footer_image'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = ResumeTemplate::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
            'status' => $this->status,
        ]);

        $query->andFilterWhere(['like', 'title', $this->title])
            ->andFilterWhere(['like', 'template_body', $this->template_body])
            ->andFilterWhere(['like', 'header_text', $this->header_text])
            ->andFilterWhere(['like', 'header_image', $this->header_image])
            ->andFilterWhere(['like', 'footer_text', $this->footer_text])
            ->andFilterWhere(['like', 'footer_image', $this->footer_image]);

        return $dataProvider;
    }
}
